#ifndef dgasJobMeteringClientUrwgImpl_h
#define dgasJobMeteringClientUrwgImpl_h

/*
 * dgasJobMeteringClientUrwgImpl.h
 * 
 * Copyright (C) 2002 by EU DataGrid.
 * For license coinditions see http://www.eu-datagrid.org/license.html
 */

#include "glite/dgas/hlr-clients/base/dgasClientBase.h"
#include "glite/dgas/common/hlr/dgas_urwg.h"
#include <string>

#define EDG_WL_DGAS_DEF_CONF "/opt/glite/etc/dgas_atmClient.conf"
namespace glite {
namespace workload {
namespace dgas {
	using namespace glite::workload::dgas::common;
	namespace dgas_common = glite::workload::dgas::common;
namespace clients {

namespace clients = glite::workload::dgas::clients;

class dgasJobMeteringClientUrwgImpl : public dgasClient
{
public:
	string confFile;
	string xmlVersion;
	/**
	 * Constructor
	 * @param h hostname of the server
	 * @param p portnumber of the server
	 * @param c contact string fro the server, optional.
	 */
	dgasJobMeteringClientUrwgImpl(const std::string& , int , const std::string& );
	/**
	 * Destructor
	 */
	~dgasJobMeteringClientUrwgImpl();
	
	/**
	 * Client init method, Wraps the communication with the server.
	 * @param ur usage records for the job to account. This is the
	 * GGF urwg implementation.
	 */
	int engage(dgas_common::urwg_UsageRecord &ur);
	
	/**
	 * Returns the answer received from the server
	 */
	string xmlServerAnswer(){return XmlServerAnswer;};

protected:

	string XmlServerAnswer;

	string composeXml(dgas_common::urwg_UsageRecord &ur);

	int  parseXml(string& xml);
	
		
};

} // namespace clients
} // namespace dgas
} // namespace workload
} // namespace edg


#endif
